//
// cocl.c - WJH 13-4-1994
// 
// compile catch list into table understandable by catch v3.0
//
// This will contain specifications for the following:
// - which registers for interrupts/registervalues combinations to log
// - which combinations to ignore
//
// input format:
//
//   Ixx R0=zzzz ....  : R1 R2  [R3:R4,00]  [R5:R6LR7] ...
// meaning: when INT xx occurs, R0 has value zzzz
//          then store values for R1, R2,  00-terminated string at R3:R4
//               R7-length string at R5:R6
//
// <intno> <Rspec> <value-list> <Rspec>
//
// IP SW CS: DS: ES: SS: DI SI BP SP AH AL BH AL CH AL DH AL
// - 18 registers
// need flags for:
//    more to follow
//    this is a mask sequence telling which values follow or to store
//    this is a ptr sequence, 1st seg, 2nd off, 3rd termination(len/char)
//   in trigger specifier:
// bit7:  1=last specifier
// bit65: 00=this is a regindex, with value to match
// bit65: 01=this is a regindex, with value not to exceed
// bit65: 10=this is a regindex, with value not to go below
// bit65: 11=this is a regindex, with value not to match
//
//   in storage specifier:
// bit65: 00=this is a regindex, whose value to store
// bit65: 01=this is a flagset,  specifying regs to store
// bit65: 10=this is a ptr seq, terminated with a char
// bit65: 11=this is a ptr seq, with length
// bit43210: regindex (if bit65!=01), otherwise 1 word follows (with bitmask)
//
//  bitvalues in case of bitmask (type 01)
// bit00:  al
// bit01:  ah
// bit02:  cl
// bit03:  ch
// bit04:  dl
// bit05:  dh
// bit06:  bl
// bit07:  bh
// bit08:  sp
// bit09:  bp
// bit0a:  si
// bit0b:  di
// bit0c:  es
// bit0d:  cs
// bit0e:  ss
// bit0f:  ds
// bit10:  fs
// bit11:  gs
// bit12:  ip
// bit13:  sw
// bit14:  ---- make this a 'short' flag: just store occurence of int
// bit15:  actionbit0
// bit16:  actionbit1
// bit17:  lastspec
// bit18:
// bit19:
// bit1a:
// bit1b:
// bit1c:
// bit1d:
// bit1e:
// bit1f:

int main(int argc, char **argv)
{

}

when entering catch:

check if catch active, mark active
   Y: add intno+CSIPSW [ISR,Ito missed queue, exit int
N: check if buffer full
   Y: exit int
N: call processint

missed_buf label word
        dw  MISBUFSIZE*4  dup(?)
missed_head label word        ; new entries are added here
        dw  0
missed_tail label word        ; when copying buf, taken from here
        dw  0
missed_length label word      ; # entries currently in missed buffer
        dw  0
total_mis_count label word
        dw  0


entry:
        push bp
        pushf
        dec  _active
        jl   is_active
        mov  bp,buffer_ptr
        cmp  bp,buffer_end
        jl

        mov  bp, 0             ; intno is filled in here
        call process_int

is_active:
        cli
        dec  missed_length
        jl   total_mis

total_mis:
        inc  total_mis_count
        inc  missed_length
exit_int:
        popf
        pop  bp
        inc  _active
label intvec  dword  $+1
        jmp  far 0:0


