#include <fcntl.h>
#include <io.h>
#include <dos.h>
#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>

typedef unsigned char byte;
typedef unsigned int  word;
struct rec {
  long timer;
  word regs[11];
  void far *p;
  word flags;
};

struct memblk {
  void far *start;
  struct memblk *n;
} *list=NULL, *end=NULL;

void block(void far *mem)
{
  struct memblk *p;
  p=(struct memblk *)malloc(sizeof(struct memblk));
  if (p==NULL)
  {
    printf("Out of memory\n");
    exit(1);
  }
  p->start=mem;
  p->n=NULL;
  if (end)
    end->n=p;
  else
    list=p;
  end=p;
}

void dumpw(word *w, int n)
{
  while (n--) printf("%04x ",*w++);
}

void dumplist(struct memblk *p)
{
  while (p)
  {
    printf("u %Fpl1\n",p->start);
    free(p);
    p=p->n;
  }
}

void main(int argc, char **argv)
{
  int f;
  int bufptr;
  int bufend;
  struct rec buf[16];
  struct rec *p;
  while (--argc)
  {
    argv++;
    f=open(*argv, O_RDONLY|O_BINARY);
    if (f<0)
    {
      perror(*argv);
      continue;
    }
    printf("\n\n    %s\n",*argv);
    printf("\n  timer  ofs  seg  flag  di   si   dx   cx   bx   ax   ss   es   ds   sp   bp\n");
    bufend=bufptr=16;
    while (!eof(f))
    {
      if (bufptr==bufend)
      {
        bufend=read(f,buf,sizeof(buf))/sizeof(struct rec);
        bufptr=0;
      }
      p=&buf[bufptr++];
      printf("%08lx %Fp %04x",p->timer, p->p, p->flags);
      dumpw(p->regs,11);
      block(p->p);
      putchar('\n');
    }
    dumplist(list);
  }
}
