#include <dos.h>
#include <stdio.h>
#include <stdlib.h>

typedef unsigned char byte;
typedef unsigned short word;

#define NINTS 10

struct catch {
  word intcounter[NINTS];
  int nentries;
  int maxbuf;
  char far *lastentry;
  char far *buffer;
  void far *oldint;
  void far *oldinttab[NINTS];
  void near *catchtab[NINTS];
  byte intnrs[NINTS];
  char curint;
  char curintno;
  int nints;
};

struct mcb {
  char flag;
  int  owner;
  int len;
};

int get1stmcb()
{
  union REGS r;
  struct SREGS s;
  int far *p;
  r.x.ax=0x5200;
  int86x(0x21,&r, &r, &s);
  p=MK_FP(s.es, r.x.bx-2);
  return(*p);
}

char *signature="interrupt$catch";

#define SIGOFFSET  0x0103

int locate()
{
  int mcbseg;
  struct mcb far *mcb;
  char far *p;
  char *s;
  mcbseg=get1stmcb();
  do {
    mcb=MK_FP(mcbseg,0);
    p=MK_FP(mcb->owner, SIGOFFSET);
    s=signature;
    while (*s && *p==*s)  { p++; s++; }
    if (*s==0) return mcb->owner;
    mcbseg+=mcb->len+1;
  }  while (mcb->flag=='Z' || mcb->flag=='M');
  return 0;
}

int toeven(int n)
{
  if (n&1)
    return n+1;
  else
    return n;
}

long normptr(void far *p)
{
  return ((long)FP_SEG(p)<<4)+FP_OFF(p);
}

/***************************
  searches memory, starting at *p, for ptr
*/
int searchmem(long *p, long *vector)
{
  byte far *q;


  (*p)++;
  if (*p<0x100000)
    q=MK_FP((*p)>>4, (*p)&0xf);
  else if (*p<0x10fff0)
    q=MK_FP(0xffff, (*p)-0xffff0);
  else return 0;

  while (FP_SEG(q)!=0xffff)
  {
    if (*(long *)q==*vector)
    {
      *p=normptr(q);
      if (*p!=normptr(vector)) return 1;
    }
    q++;
    if (FP_OFF(q)==0x10) q=MK_FP(FP_SEG(q)+1, 0);
  }
  q=MK_FP(0xffff, 0x0);
  while (FP_OFF(q)<=0xfffc)
  {
    if (*(long *)q==*vector)
    {
      *p=normptr(q);
      if (*p!=normptr(vector)) return 1;
    }
    q++;
  }
  return 0;
}

void main(int argc, char **argv)
{
  int psp;
  int verbose=0;
  struct catch far *data;
  void far *catch;
  int i;
  void far *intvec;
  long p;

  if (argc>1) verbose++;
  psp=locate();
  if (psp==0)
  {
    printf("Could not find catch!\n");
    return;
  }
  printf("Catch found at segment %04x\n", psp);
  data=MK_FP(psp, toeven(SIGOFFSET+strlen(signature)));
  printf("nentries = %d, nints = %d,  curintno=%d, curint=%02x\n",
    data->nentries, data->nints, data->curintno, data->curint);
  printf("buffer=%Fp, maxbuf=%04x, lastent=%Fp, oldint=%Fp\n",
     data->buffer, data->maxbuf, data->lastentry, data->oldint);
  printf("n  : int catch  oldint      count\n");
  for (i=0 ; i<data->nints ; i++)
  {
    printf("%2d : %02x  %04Np  %Fp  %5d",
      i, data->intnrs[i], data->catchtab[i],
      data->oldinttab[i], data->intcounter[i]);
    catch=MK_FP(psp, data->catchtab[i]);
    if (data->intnrs[i]==0xff)
      printf("   shutdown\n");
    else {
      intvec=(void far *)_dos_getvect(data->intnrs[i]);
      if (intvec!=catch)
        printf("  revectored to %Fp", intvec);
      if (verbose)
      {
        p=0;
        while (searchmem(&p, (long *)&catch))
          printf(" %06lx", p);
      }
      putchar('\n');
    }
  }
}
