typedef unsigned int word;
typedef unsigned char byte;
typedef unsigned long dword;

#define FALSE 0
#define TRUE 1
typedef unsigned char bool;

struct textID {
  int id;
  int flag;       // determines where index for subtable comes from
  union {
    char *format;
    struct textID *table;
  } sub;
  char *general;
};

// flag is one of:
#define END         (0x0000)
#define OFFSET      (0x8000)
#define REG_BYTE    (0x0020)
#define REG_WORD    (0x0010)
#define INTERRUPT_NUMBER (0x0040)

#define REG_AL      (0|REG_BYTE)
#define REG_AH      (1|REG_BYTE)
#define REG_BL      (2|REG_BYTE)
#define REG_BH      (3|REG_BYTE)
#define REG_CL      (4|REG_BYTE)
#define REG_CH      (5|REG_BYTE)
#define REG_DL      (6|REG_BYTE)
#define REG_DH      (7|REG_BYTE)


//  struct int_rec *rec;   ((word *)&(rec->AX))[..]
#define REG_AX      (0x0|REG_WORD)
#define REG_BX      (0x1|REG_WORD)
#define REG_CX      (0x2|REG_WORD)
#define REG_DX      (0x3|REG_WORD)
#define REG_DS      (0x4|REG_WORD)
#define REG_SI      (0x5|REG_WORD)
#define REG_ES      (0x6|REG_WORD)
#define REG_DI      (0x7|REG_WORD)
#define REG_SS      (0x8|REG_WORD)
#define REG_SP      (0x9|REG_WORD)
#define REG_BP      (0xa|REG_WORD)
#define REG_IP      (0xb|REG_WORD)
#define REG_CS      (0xc|REG_WORD)
#define REG_FLAG    (0xd|REG_WORD)

//   these are regs defined in internal cpu order
// #define REG_AL      (0|REG_BYTE)
// #define REG_CL      (1|REG_BYTE)
// #define REG_DL      (2|REG_BYTE)
// #define REG_BL      (3|REG_BYTE)
// #define REG_AH      (4|REG_BYTE)
// #define REG_CH      (5|REG_BYTE)
// #define REG_DH      (6|REG_BYTE)
// #define REG_BH      (7|REG_BYTE)
// #define REG_AX      (0|REG_WORD)
// #define REG_CX      (1|REG_WORD)
// #define REG_DX      (2|REG_WORD)
// #define REG_BX      (3|REG_WORD)
// #define REG_SP      (4|REG_WORD)
// #define REG_BP      (5|REG_WORD)
// #define REG_SI      (6|REG_WORD)
// #define REG_DI      (7|REG_WORD)

struct int_rec {
  byte reclen;
  byte intno;
  int n;
  long time;
  word AX;
  word BX;
  word CX;
  word DX;
  word DS;
  word SI;
  word ES;
  word DI;
  word SS;
  word SP;
  word BP;
  word IP;
  word CS;
  word flags;
};

extern struct textID mainTable[];
