#include <stdio.h>
#include "lst.h"        

struct textID int215f[]={
 { 0x00, END, "Get Redirection Mode", NULL},
 { 0x01, END, "Set Redirection Mode", NULL},
 { 0x02, END, "Get Redirection List Entry", NULL},
 { 0x03, END, "Redirect Device", NULL},
 { 0x04, END, "Cancel Redirection", NULL},
 { 0x05, END, "Get Extended Redirection List Entry", NULL},
 { 0x06, END, "Get Full Redirection List", NULL},
 { 0x07, END, "Enable Drive", NULL},
 { 0x08, END, "Disable Drive", NULL},
 { -1, -1, NULL, NULL}
};

struct textID int21f1[]={
 { 0x00, END, "Attach to FileServer %Rdl", NULL},  // DL=conn
 { 0x01, END, "Detach from FileServer %Rdl", NULL},  // DL=conn
 { 0x02, END, "Logout from FileServer %Rdl", NULL},  // DL=conn
 { -1, -1, NULL, NULL}
};

struct textID int21f0[]={
 { 0x00, END, "Set Preferred Connection ID to %Rdl", NULL}, // to DL
 { 0x01, END, "Get Preferred Connection ID", NULL},      // -> AL
 { 0x02, END, "Get Default Connection ID", NULL},        // -> AL
 { 0x03, END, "Get LPT Capture Status", NULL},           // -> AL, AH=flag
 { 0x04, END, "Set Primary Connection ID to %Rdl", NULL},   // to DL
 { 0x05, END, "Get Primary Connection ID", NULL},        // -> AL
 { -1, -1, NULL, NULL}
};

struct textID int21ef[]={
 { 0x00, END, "Get Drive Handle Table", NULL},        // -> ESSI
 { 0x01, END, "Get Drive Flag Table", NULL},          // -> ESSI
 { 0x02, END, "Get Drive Connection Table", NULL},    // -> ESSI
 { 0x03, END, "Get Connection Table", NULL},          // -> ESSI
 { 0x04, END, "Get File Server Nametable", NULL},     // -> ESSI
 { -1, -1, NULL, NULL}
};

struct textID NCP11fns[]={
 { 0x00, END, "Write To A Spool File", NULL},
 { 0x01, END, "Close Spool File", NULL},
 { 0x02, END, "Set Spool File Flags", NULL},
 { 0x03, END, "Spool A Disk File", NULL},
 { 0x04, END, "Get Spool Queue Entry", NULL},
 { 0x05, END, "Remove Entry From Spool Queue", NULL},
 { 0x06, END, "Get Printer Status", NULL},
 { 0x09, END, "Specify Capture File", NULL},
 { 0x0a, END, "Get Printer Queue", NULL},
 { -1, -1, NULL, NULL}
};

struct textID NCP15fns[]={
 { 0x00, END, "Send Broadcast Message(old)", NULL},
 { 0x01, END, "Get Broadcast Message(old)", NULL},
 { 0x02, END, "Disable Station Broadcasts", NULL},
 { 0x03, END, "Enable Station Broadcasts", NULL},
 { 0x04, END, "Send Personal Message", NULL},
 { 0x05, END, "Get Personal Message", NULL},
 { 0x06, END, "Open Message Pipe", NULL},
 { 0x07, END, "Close Message Pipe", NULL},
 { 0x08, END, "Check Pipe Status", NULL},
 { 0x09, END, "Broadcast to Console", NULL},
 { 0x0a, END, "Send Broadcast Message(new)", NULL},
 { 0x0b, END, "Get Broadcast Message(new)", NULL},
 { -1, -1, NULL, NULL}
};

struct textID NCP16fns[]={
 { 0x00, END, "Set Directory Handle", NULL},
 { 0x01, END, "Get Directory Path", NULL},
 { 0x02, END, "Scan Directory Information", NULL},
 { 0x03, END, "Get Effective Directory Rights(old)", NULL},
 { 0x04, END, "Modify Maximum Rights Mask", NULL},
 { 0x05, END, "Get Volume Number", NULL},
 { 0x06, END, "Get Volume Name", NULL},
// 0x07
// 0x08
// 0x09
 { 0x0a, END, "Create Directory", NULL},
 { 0x0b, END, "Delete Directory", NULL},
 { 0x0c, END, "Scan Directory For Trustees", NULL},
 { 0x0d, END, "Add Trustee to Directory", NULL},
 { 0x0e, END, "Delete Trustee From Directory", NULL},
 { 0x0f, END, "Rename Directory", NULL},
 { 0x10, END, "Purge Erased Files(old)", NULL},
 { 0x11, END, "Restore Erased File", NULL},
 { 0x12, END, "Allocate Permanent Directory Handle", NULL},
 { 0x13, END, "Allocate Temporary Directory Handle", NULL},
 { 0x14, END, "Deallocate Directory Handle", NULL},
 { 0x15, END, "Get Volume Info With Handle", NULL},
 { 0x16, END, "Allocate Special Temporary Directory Handle", NULL},
 { 0x17, END, "Save Directory Handle", NULL},
 { 0x18, END, "Restore Directory Handle", NULL},
 { 0x19, END, "Set Directory Information", NULL},
 { 0x1a, END, "Get Path From Directory Entry", NULL},
 { 0x1b, END, "Scan Salvageable Files(old)", NULL},
 { 0x1c, END, "Recover Salvageable File(old)", NULL},
 { 0x1d, END, "Purge Salvageable File(old)", NULL},
 { 0x1e, END, "Scan Dir Entry", NULL},
 { 0x1f, END, "Get Dir Entry", NULL},
 { 0x20, END, "Scan Volume For Restrictions", NULL},
 { 0x21, END, "Add User Disk Space Restriction", NULL},
 { 0x22, END, "Clear Volume Restrictions", NULL},
 { 0x23, END, "Get Dir Restrictions", NULL},
 { 0x24, END, "Set Dir Space Restriction", NULL},
 { 0x25, END, "Set Directory Entry Information", NULL},
 { 0x26, END, "Scan File or Dir for Extended Trustees", NULL},
 { 0x27, END, "Add Extended Trustee to File/Dir", NULL},
 { 0x28, END, "Scan Directory Disk Space", NULL},
 { 0x29, END, "Get Object Disk Restrictions", NULL},
 { 0x2a, END, "Get Effective Rights By Dir Entry", NULL},
 { 0x2b, END, "Delete Extended Trustee From Directory or File", NULL},
 { 0x2c, END, "Get Volume Usage", NULL},
 { 0x2d, END, "Get Dir Info", NULL},
 { 0x2e, END, "Move Entry", NULL},
 { 0x2f, END, "Get Name Space Buffer Information", NULL},
 { 0x30, END, "Get Name Space Directory Entry", NULL},
 { 0x31, END, "Open Data Stream", NULL},
 { 0x32, END, "Get Object Effective Rights", NULL},
 { 0x33, END, "Get Extended Volume Info", NULL},
 { -1, -1, NULL, NULL}
};

struct textID NCP17fns[]={
// { 0x11, END, "Recover Erased File(old)", NULL},
 { 0x00, END, "Login User Object", NULL},
 { 0x01, END, "Change User Password", NULL},
 { 0x02, END, "Get User Connection List(old)", NULL},
 { 0x03, END, "Map Object To Number", NULL},
 { 0x04, END, "Map Number To Object", NULL},
 { 0x05, END, "Get Connection Information(new)/Station Logged Info", NULL},
// 0x06
// 0x07
 { 0x08, END, "Map Number To Group Name", NULL},
 { 0x09, END, "Get Member Set M of Group G", NULL},
 { 0x0a, END, "Enter Login Area", NULL},
// 0x0b
 { 0x0c, END, "Verify Network Serial Number", NULL},
 { 0x0d, END, "Log Network Message", NULL},
 { 0x0e, END, "Get Disk Utilization for Trustee", NULL},
 { 0x0f, END, "Scan File Information", NULL},
 { 0x10, END, "Set File Information", NULL},
 { 0x11, END, "Get File Server Information", NULL},
 { 0x12, END, "Get Network Serial Number", NULL},
 { 0x13, END, "Get Internet Address(old)", NULL},
 { 0x14, END, "Login Object", NULL},
 { 0x15, END, "Get Object Connection List(old)", NULL},
 { 0x16, END, "Get Connection Information(old)", NULL},
 { 0x17, END, "Get Encryption Key", NULL},
 { 0x18, END, "Login Object Encrypted", NULL},
// 0x19
 { 0x1a, END, "Get Internet Address(new)", NULL},
 { 0x1b, END, "Get Object Connection List(new)", NULL},
 { 0x1c, END, "Get Connection Information(new)/Station Logged Info", NULL},
 { 0x1d, END, "Change Connection State", NULL},
 { 0x1e, END, "Set Watchdog Delay Interval", NULL},
 { 0x1f, END, "Get Connection List From Object", NULL},
// 0x20  - 0x31
 { 0x32, END, "Create Bindery Object", NULL},
 { 0x33, END, "Delete Bindery Object", NULL},
 { 0x34, END, "Rename Bindery Object", NULL},
 { 0x35, END, "Get Bindery Object ID", NULL},
 { 0x36, END, "Get Bindery Object Name", NULL},
 { 0x37, END, "Scan Bindery Object", NULL},
 { 0x38, END, "Change Bindery Object Security", NULL},
 { 0x39, END, "Create Property", NULL},
 { 0x3a, END, "Delete Property", NULL},
 { 0x3b, END, "Change Property Security", NULL},
 { 0x3c, END, "Scan Property", NULL},
 { 0x3d, END, "Read Property Value", NULL},
 { 0x3e, END, "Write Property Value", NULL},
 { 0x3f, END, "Verify Bindery Object Password", NULL},
 { 0x40, END, "Change Bindery Object Password", NULL},
 { 0x41, END, "Add Bindery Object to Set", NULL},
 { 0x42, END, "Delete Bindery Object From Set", NULL},
 { 0x43, END, "Is Bindery Object In Set", NULL},
 { 0x44, END, "Close Bindery", NULL},
 { 0x45, END, "Open Bindery", NULL},
 { 0x46, END, "Get Bindery Access Level", NULL},
 { 0x47, END, "Scan Bindery Object Trustee Paths", NULL},
 { 0x48, END, "Get Bindery Object Access Level", NULL},
 { 0x49, END, "Is Station A Manager", NULL},
 { 0x4a, END, "Verify Bindery Object Password Encrypted", NULL},
 { 0x4b, END, "Change Bindery Object Password Encrypted", NULL},
 { 0x4c, END, "Get Relations of an Object", NULL},
// 0x4d - 5f
 { 0x60, END, "PNW Specific", NULL},
// 0x61
// 0x62
// 0x63
 { 0x64, END, "Create Queue", NULL},
 { 0x65, END, "Destroy Queue", NULL},
 { 0x66, END, "Read Queue Current Status(old)", NULL},
 { 0x67, END, "Set Queue Current Status(old)", NULL},
 { 0x68, END, "Create Queue Job And File(old)", NULL},
 { 0x69, END, "Close File And Start Queue Job(old)", NULL},
 { 0x6a, END, "Remove Job From Queue(old)", NULL},
 { 0x6b, END, "Get Queue Job List(old)", NULL},
 { 0x6c, END, "Read Queue Job Entry(old)", NULL},
 { 0x6d, END, "Change Queue Job Entry(old)", NULL},
 { 0x6e, END, "Change Queue Job Position", NULL},
 { 0x6f, END, "Attach Queue Server To Queue", NULL},
 { 0x70, END, "Detach Queue Server From Queue", NULL},
 { 0x71, END, "Service Queue Job And Open File(old)", NULL},
 { 0x72, END, "Finish Servicing Queue Job(old)", NULL},
 { 0x73, END, "Abort Servicing Queue Job(old)", NULL},
 { 0x74, END, "Change To Client Rights(old)", NULL},
 { 0x75, END, "Restore Queue Server Rights", NULL},
 { 0x76, END, "Read Queue Server Current Status(old)", NULL},
 { 0x77, END, "Set Queue Server Current Status", NULL},
 { 0x78, END, "Get Queue Job File Size(old)", NULL},
 { 0x79, END, "Create Queue Job And File(new)", NULL},
 { 0x7a, END, "Read Queue Job Entry(new)", NULL},
 { 0x7b, END, "Change Queue Job Entry(new)", NULL},
 { 0x7c, END, "Service Queue Job(new)", NULL},
 { 0x7d, END, "Read Queue Current Status(new)", NULL},
 { 0x7e, END, "Set Queue Current Status(new)", NULL},
 { 0x7f, END, "Close File And Start Queue Job(new)", NULL},
 { 0x80, END, "Remove Job From Queue(new)", NULL},
 { 0x81, END, "Get Queue Job List(new)", NULL},
 { 0x82, END, "Change Queue Job Order/Priority", NULL},
 { 0x83, END, "Finish Servicing Queue Job(new)", NULL},
 { 0x84, END, "Abort Servicing Queue Job(new)", NULL},
 { 0x85, END, "Change To Client Rights(new)", NULL},
 { 0x86, END, "Read Queue Server Current Status(new)", NULL},
 { 0x87, END, "Get Queue Job File Size(new)", NULL},
 { 0x88, END, "Move Queue Job From SrcQ to DstQ", NULL},
 { 0x89, END, "Get Q Jobs From Form List", NULL},
 { 0x8a, END, "Service Q Job By Form List", NULL},
// 0x8b - 0x95
 { 0x96, END, "Get Account Status", NULL},
 { 0x97, END, "Submit Account Charge", NULL},
 { 0x98, END, "Submit Account Hold", NULL},
 { 0x99, END, "Submit Account Note", NULL},
// 0x9a - 0xc7
 { 0xc8, END, "Check Console Privileges", NULL},
 { 0xc9, END, "Get File Server Description Strings", NULL},
 { 0xca, END, "Set File Server Date And Time", NULL},
 { 0xcb, END, "Disable File Server Login", NULL},
 { 0xcc, END, "Enable File Server Login", NULL},
 { 0xcd, END, "Get File Server Login Status", NULL},
 { 0xce, END, "Purge Erased Files(new)", NULL},
 { 0xcf, END, "Disable Transaction Tracking", NULL},
 { 0xd0, END, "Enable Transaction Tracking", NULL},
 { 0xd1, END, "Send Console Broadcast(old)", NULL},
 { 0xd2, END, "Clear Connection Number(old)", NULL},
 { 0xd3, END, "Down File Server", NULL},
 { 0xd4, END, "Get File System Statistics", NULL},
 { 0xd5, END, "TTS Get Statistics", NULL},
 { 0xd6, END, "Get Disk Cache Statistics", NULL},
 { 0xd7, END, "Get Drive Mapping Table", NULL},
 { 0xd8, END, "Get Physical Disk Statistics", NULL},
 { 0xd9, END, "Get Disk Channel Statistics", NULL},
 { 0xda, END, "Get Connection's Task Information(old)", NULL},
 { 0xdb, END, "Get Connection's Open Files(old)", NULL},
 { 0xdc, END, "Get Connections Using A File(old)", NULL},
 { 0xdd, END, "Get Physical Record Locks By Connection And File(old)", NULL},
 { 0xde, END, "Get Physical Record Locks By File(old)", NULL},
 { 0xdf, END, "Get Logical Records By Connection(old)", NULL},
 { 0xe0, END, "Get Logical Record Information(old)", NULL},
 { 0xe1, END, "Get Connection's Semaphores(old)", NULL},
 { 0xe2, END, "Get Semaphore Information(old)", NULL},
 { 0xe3, END, "Get LAN Driver's Configuration Information", NULL},
// 0xe4
 { 0xe5, END, "Get Connection's Usage Statistics", NULL},
 { 0xe6, END, "Get Bindery Object Disk Space Left", NULL},
 { 0xe7, END, "Get File Server LAN I/O Statistics", NULL},
 { 0xe8, END, "Get File Server Misc Information", NULL},
 { 0xe9, END, "Get Volume Information", NULL},
 { 0xea, END, "Get Connection's Task Information(new)", NULL},
 { 0xeb, END, "Get Connection's Open Files(new)", NULL},
 { 0xec, END, "Get Connections Using A File(new)", NULL},
 { 0xed, END, "Get Physical Record Locks By Connection And File(new)", NULL},
 { 0xee, END, "Get Physical Record Locks By File(new)", NULL},
 { 0xef, END, "Get Logical Records By Connection(new)", NULL},
 { 0xf0, END, "Get Logical Record Information(new)", NULL},
 { 0xf1, END, "Get Connection's Semaphores(new)", NULL},
 { 0xf2, END, "Get Semaphore Information(new)", NULL},
 { 0xf3, END, "Map Directory Number to Path", NULL},
 { 0xf4, END, "Convert Path To Dir Entry", NULL},
 { 0xf5, END, "Get File Server Extended Misc Information", NULL},
 { 0xf6, END, "Get Volume Extended Information", NULL},
// 0xf7
// 0xf8
// 0xf9
// 0xfa
// 0xfb
// 0xfc
 { 0xfd, END, "Send Console Broadcast(new)", NULL},
 { 0xfe, END, "Clear Connection Number(new)", NULL},
// 0xff
 { -1, -1, NULL, NULL}
};

struct textID NCP20fns[]={
 { 0x00, END, "Open Semaphore(old)", NULL},
 { 0x01, END, "Examine Semaphore(old)", NULL},
 { 0x02, END, "Wait On Semaphore(old)", NULL},
 { 0x03, END, "Signal Semaphore(old)", NULL},
 { 0x04, END, "Close Semaphore(old)", NULL},
 { -1, -1, NULL, NULL}
};

struct textID NCP22fns[]={
 { 0x00, END, "TTS Is Available", NULL},
 { 0x01, END, "TTS Begin Transaction", NULL},
 { 0x02, END, "TTS End Transaction", NULL},
 { 0x03, END, "TTS Abort Transaction", NULL},
 { 0x04, END, "TTS Transaction Status", NULL},
 { 0x05, END, "TTS Get Application Thresholds", NULL},
 { 0x06, END, "TTS Set Application Thresholds", NULL},
 { 0x07, END, "TTS Get Workstation Thresholds", NULL},
 { 0x08, END, "TTS Set Workstation Thresholds", NULL},
 { 0x09, END, "TTS Get Control Flags", NULL},
 { 0x0a, END, "TTS Set Control Flags", NULL},
 { -1, -1, NULL, NULL}
};

struct textID NCP23fns[]={
// 0x00
 { 0x01, END, "AFP Create Directory", NULL},
 { 0x02, END, "AFP Create File", NULL},
 { 0x03, END, "AFP Delete", NULL},
 { 0x04, END, "AFP Get Entry ID From Name", NULL},
 { 0x05, END, "AFP Get File Information", NULL},
 { 0x06, END, "AFP Get Entry ID From Netware Handle", NULL},
 { 0x07, END, "AFP Rename", NULL},
 { 0x08, END, "AFP Open File Fork", NULL},
 { 0x09, END, "AFP Set File Information", NULL},
 { 0x0a, END, "AFP Scan File Information", NULL},
 { 0x0b, END, "AFP Alloc Temporary Dir Handle", NULL},
 { 0x0c, END, "AFP Get Entry ID From Path Name", NULL},
 { 0x0d, END, "AFP New Create Directory", NULL},
 { 0x0e, END, "AFP New Create File", NULL},
 { 0x0f, END, "AFP New Get File Information", NULL},
 { 0x10, END, "AFP New Set File Information", NULL},
 { 0x11, END, "AFP New Scan File Information", NULL},
 { 0x12, END, "AFP Map MacID To DOS Name", NULL},
 { 0x13, END, "AFP Get Deleted File Info", NULL},
 { -1, -1, NULL, NULL}
};

struct textID NCP56fns[]={
// 0x00
 { 0x01, END, "Close Extended Attribute Handle", NULL},
 { 0x02, END, "Write Extended Attribute", NULL},
 { 0x03, END, "Read Extended Attribute", NULL},
 { 0x04, END, "Enumerate Extended Attribute", NULL},
 { 0x05, END, "Duplicate Extended Attribute", NULL},
 { -1, -1, NULL, NULL}
};

struct textID NCP57fns[]={
// 0x00
 { 0x01, END, "Open Create File or Directory", NULL},
 { 0x02, END, "Initialize Search", NULL},
 { 0x03, END, "Search For File Or Directory", NULL},
 { 0x04, END, "Rename or Move a File or Directory", NULL},
 { 0x05, END, "Scan File or Dir for Trustees", NULL},
 { 0x06, END, "Obtain File Or Sub Dir Information", NULL},
 { 0x07, END, "Modify File Or Sub Dir DOS Information", NULL},
 { 0x08, END, "Delete File Or Directory", NULL},
 { 0x09, END, "Set Short Directory Handle", NULL},
 { 0x0a, END, "Add Trustee Set To File or Directory", NULL},
 { 0x0b, END, "Delete Trustee Set", NULL},
 { 0x0c, END, "Allocate Short Directory Handle", NULL},
// 0x0d
// 0x0e
// 0x0f
 { 0x10, END, "Scan Salvageable Files(new)", NULL},
 { 0x11, END, "Recover Salvageable File(new)", NULL},
 { 0x12, END, "Purge Salvageable File(new)", NULL},
 { 0x13, END, "Get NS Information", NULL},
 { 0x14, END, "Search For File Or Directory Set", NULL},
 { 0x15, END, "Get A Directory Path From Handle", NULL},
 { 0x16, END, "Generate Dir Base And Vol Number", NULL},
 { 0x17, END, "Query NS Info Format", NULL},
 { 0x18, END, "Get Name Space Loaded List", NULL},
 { 0x19, END, "Set NS Information", NULL},
 { 0x1a, END, "Get Huge NS Information", NULL},
 { 0x1b, END, "Set Huge NS Information", NULL},
 { 0x1c, END, "Get Full Path String", NULL},
 { 0x1d, END, "Get Effective Directory Rights(new)", NULL},
 { 0x1e, END, "Open Create File", NULL},
 { -1, -1, NULL, NULL}
};

struct textID NCP58fns[]={
// 0x00
 { 0x01, END, "Get Volume Audit Statistics", NULL},
 { 0x02, END, "Add Audit Property", NULL},
 { 0x03, END, "Login As Volume Editor", NULL},
 { 0x04, END, "Change Auditor Password", NULL},
 { 0x05, END, "Check Audit Access", NULL},
 { 0x06, END, "Remove Audit Property", NULL},
 { 0x07, END, "Disable Auditing On Volume", NULL},
 { 0x08, END, "Enable Auditing On Volume", NULL},
 { 0x09, END, "Is User Audited", NULL},
 { 0x0a, END, "Read Auditing Bit Map", NULL},
 { 0x0b, END, "Read Audit Config Header", NULL},
 { 0x0c, END, "Read Auditing File", NULL},
 { 0x0d, END, "Logout As Volume Auditor", NULL},
 { 0x0e, END, "Reset Auditing File", NULL},
 { 0x0f, END, "Reset Audit History File", NULL},
 { 0x10, END, "Write Auditing Bit Map", NULL},
 { 0x11, END, "Write Audit Config Header", NULL},
 { 0x12, END, "Change Audit Password 2", NULL},
 { 0x13, END, "Get Auditing Flags", NULL},
 { 0x14, END, "Close Old Auditing File", NULL},
 { 0x15, END, "Delete Old Auditing File", NULL},
 { 0x16, END, "Check Audit Level Two Access", NULL},
 { -1, -1, NULL, NULL}
};

struct textID NCP5afns[]={
// 0x00
 { 0x01, END, "Get DM Info", NULL},
// 0x02 - 0x7f  unused
 { 0x80, END, "Move File Data To DM", NULL},
 { 0x81, END, "DM File Information", NULL},
 { 0x82, END, "Volume DM Status", NULL},
 { 0x83, END, "Migrate Stat Info", NULL},
 { 0x84, END, "DM Support Module Information", NULL},
 { 0x85, END, "Move File Data From DM", NULL},
 { 0x86, END, "Get or Set Default Support Module", NULL},
 { -1, -1, NULL, NULL}
};

struct textID NCP60fns[]={
// 0x00
 { 0x01, END, "Get File Server Stats", NULL},
 { 0x02, END, "Get File Server TTS", NULL},
 { 0x03, END, "Get File Server Sync", NULL},
 { -1, -1, NULL, NULL}
};

struct textID NCP68fns[]={
 { 0x00, END, "Old Fragger Protocol", NULL},
 { 0x01, END, "Ping Request", NULL},
 { 0x02, END, "New Fragger Protocol", NULL},
 { 0x03, END, "Fragment Close", NULL},
 { 0x04, END, "Bindery Context", NULL},
 { 0x05, END, "Monitor Connection", NULL},
 { -1, -1, NULL, NULL}
};

struct textID NCP6ffns[]={
 { 0x00, END, "Open Semaphore(new)", NULL},
 { 0x01, END, "Examine Semaphore(new)", NULL},
 { 0x02, END, "Wait On Semaphore(new)", NULL},
 { 0x03, END, "Signal Semaphore(new)", NULL},
 { 0x04, END, "Close Semaphore(new)", NULL},
 {   -1, NULL}
};

struct textID NCP7bfns[]={
 { 0x01, END, "Get Cache Information", NULL},
 { 0x02, END, "Get File Server Information", NULL},
 { 0x03, END, "Get NetWare File Systems Information", NULL},
 { 0x04, END, "Get User Information", NULL},
 { 0x05, END, "Get Packet Burst Information", NULL},
 { 0x06, END, "Get IPX/SPX Information", NULL},
 { 0x07, END, "Get Garbage Collection Information", NULL},
 { 0x08, END, "Get CPU Information", NULL},
 { 0x09, END, "Get Volume Switch Information", NULL},
 { 0x0a, END, "Get NLM Loaded List", NULL},
 { 0x0b, END, "Get NLM Information", NULL},
 { 0x0c, END, "Get Directory Cache Information", NULL},
 { 0x0d, END, "Get OS Version Information", NULL},
 { 0x0e, END, "Get Active Connection List By Type", NULL},
 { 0x0f, END, "Get NLM's Resource Tag List", NULL},
// 0x10
// 0x11
// 0x12
// 0x13
 { 0x14, END, "Get Active LAN Board List", NULL},
 { 0x15, END, "Get LAN Configuration Information", NULL},
 { 0x16, END, "Get LAN Common Counters Information", NULL},
 { 0x17, END, "Get LAN Custom Counters Information", NULL},
 { 0x18, END, "Get LAN Config Strings", NULL},
 { 0x19, END, "Get LSL Information", NULL},
 { 0x1a, END, "Get LSL Logical Board Statistics", NULL},
// 0x1b
// 0x1c
// 0x1d
 { 0x1e, END, "Get Media Manager Object Information", NULL},
 { 0x1f, END, "Get Media Manager Object List", NULL},
 { 0x20, END, "Get Media Manager Object Children List", NULL},
 { 0x21, END, "Get Volume Segment List", NULL},
// 0x22
// 0x23
// 0x24
// 0x25
// 0x26
// 0x27
 { 0x28, END, "Get Active Protocol Stacks", NULL},
 { 0x29, END, "Get Protocol Stack Configuration Information", NULL},
 { 0x2a, END, "Get Protocol Stack Statistics Information", NULL},
 { 0x2b, END, "Get Protocol Stack Custom Information", NULL},
 { 0x2c, END, "Get Protocol Stack Numbers By Media Number", NULL},
 { 0x2d, END, "Get Protocol Stack Numbers By LAN Board Number", NULL},
 { 0x2e, END, "Get Media Name By Media Number", NULL},
 { 0x2f, END, "Get Loaded Media Number List", NULL},
// 0x30
// 0x31
 { 0x32, END, "Get General Router And SAP Information", NULL},
 { 0x33, END, "Get Network Router Information", NULL},
 { 0x34, END, "Get Network Routers Information", NULL},
 { 0x35, END, "Get Known Networks Information", NULL},
 { 0x36, END, "Get Server Information", NULL},
// 0x37
 { 0x38, END, "Get Known Servers Information", NULL},
// 0x39
// 0x3a
// 0x3b
 { 0x3c, END, "Get Server Set Commands Information", NULL},
 { 0x3d, END, "Get Server Set Categories", NULL},
 { -1, NULL, NULL}
};

struct textID int10fns[]={
  { 0x00, END, "Set video mode", NULL},
  { 0x01, END, "Set cursor type", NULL},
  { 0x02, END, "Set cursor position", NULL},
  { 0x03, END, "Read cursor position", NULL},
  { 0x04, END, "Read light pen", NULL},
  { 0x05, END, "Select active display page", NULL},
  { 0x06, END, "Scroll active page up", NULL},
  { 0x07, END, "Scroll active page down", NULL},
  { 0x08, END, "Read character and attribute at cursor", NULL},
  { 0x09, END, "Write character and attribute at cursor", NULL},
  { 0x0a, END, "Write character at current cursor", NULL},
  { 0x0b, END, "Set color palette", NULL},
  { 0x0c, END, "Write graphics pixel at coordinate", NULL},
  { 0x0d, END, "Read graphics pixel at coordinate", NULL},
  { 0x0e, END, "Write text in teletype mode", NULL},
  { 0x0f, END, "Get current video state", NULL},
  { 0x10, END, "Set/get palette registers (EGA/VGA)", NULL},
  { 0x11, END, "Character generator routine (EGA/VGA)", NULL},
  { 0x12, END, "Video subsystem configuration (EGA/VGA)", NULL},
  { 0x13, END, "Write string (BIOS after 1/10/86)", NULL},
  { 0x14, END, "Load LCD char font (convertible)", NULL},
  { 0x15, END, "Return physical display parms (convertible)", NULL},
  { 0x1a, END, "Video Display Combination (VGA)", NULL},
  { 0x1b, END, "Video BIOS Functionality/State Information (MCGA/VGA)", NULL},
  { 0x1c, END, "Save/Restore Video State  (VGA only)", NULL},
  { 0xfe, END, "Get DESQView/TopView Virtual Screen Regen Buffer", NULL},
  { 0xff, END, "Update DESQView/TopView Virtual Screen Regen Buffer", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int13fns[]={
  { 0x00, END, "Reset disk system", NULL},
  { 0x01, END, "Get disk status", NULL},
  { 0x02, END, "Read disk sectors", NULL},
  { 0x03, END, "Write disk sectors", NULL},
  { 0x04, END, "Verify disk sectors", NULL},
  { 0x05, END, "Format disk track", NULL},
  { 0x06, END, "Format track and set bad sector flag", NULL},
  { 0x07, END, "Format the drive starting at track", NULL},
  { 0x08, END, "Get current drive parameters", NULL},
  { 0x09, END, "Initialize 2 fixed disk base tables", NULL},
  { 0x0A, END, "Read long sector", NULL},
  { 0x0B, END, "Write long sector", NULL},
  { 0x0C, END, "Seek to cylinder", NULL},
  { 0x0D, END, "Alternate disk reset", NULL},
  { 0x0E, END, "Read sector buffer", NULL},
  { 0x0F, END, "Write sector buffer", NULL},
  { 0x10, END, "Test for drive ready", NULL},
  { 0x11, END, "Recalibrate drive", NULL},
  { 0x12, END, "Controller ram diagnostic", NULL},
  { 0x13, END, "Drive diagnostic", NULL},
  { 0x14, END, "Controller internal diagnostic", NULL},
  { 0x15, END, "Read disk type/DASD type", NULL},
  { 0x16, END, "Disk change line status", NULL},
  { 0x17, END, "Set dasd type for format", NULL},
  { 0x18, END, "Set media type for format", NULL},
  { 0x19, END, "Park fixed disk heads", NULL},
  { 0x1A, END, "Format ESDI drive unit", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int14fns[]={
  { 0x00, END, "Initialize serial port parameters", NULL},
  { 0x01, END, "Send character in AL", NULL},
  { 0x02, END, "Receive character in AL", NULL},
  { 0x03, END, "Get Serial port status", NULL},
  { 0x04, END, "Extended initialize", NULL},
  { 0x05, END, "Extended communication port control", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int15fns[]={
  { 0x00, END, "Turn cassette motor on", NULL},
  { 0x01, END, "Turn cassette motor off", NULL},
  { 0x02, END, "Read blocks from cassette", NULL},
  { 0x03, END, "Write blocks to cassette", NULL},
  { 0x0f, END, "PS/2 format periodic interrupt", NULL},
  { 0x20, END, "PRINT.COM Critical region flag", NULL},
  { 0x21, END, "PS/2 power on self test", NULL},
  { 0x40, END, "Read / modify profiles", NULL},
  { 0x41, END, "Wait on external event", NULL},
  { 0x42, END, "Request system power off", NULL},
  { 0x43, END, "Read system status", NULL},
  { 0x44, END, "(De)activate internal modem power", NULL},
  { 0x4f, END, "Keyboard intercept", NULL},
  { 0x80, END, "Device open", NULL},
  { 0x81, END, "Device close", NULL},
  { 0x82, END, "Program termination", NULL},
  { 0x83, END, "Event wait", NULL},
  { 0x84, END, "Joy-Stick support", NULL},
  { 0x85, END, "System request key pressed", NULL},
  { 0x86, END, "Elapsed time wait", NULL},
  { 0x87, END, "Move block to/from extended memory", NULL},
  { 0x88, END, "Extended memory size determination", NULL},
  { 0x89, END, "Switch processor to protected mode", NULL},
  { 0x90, END, "Device busy", NULL},
  { 0x91, END, "Interrupt complete", NULL},
  { 0xc0, END, "Return system configuration parameters", NULL},
  { 0xc1, END, "Return extended BIOS data address", NULL},
  { 0xc2, END, "Pointing device BIOS interface", NULL},
  { 0xc3, END, "Enable/Disable watchdog timer", NULL},
  { 0xc4, END, "Programmable option select", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int16fns[]={
  { 0x00, END, "Wait for keystroke and read", NULL},
  { 0x01, END, "Get keystroke status", NULL},
  { 0x02, END, "Get shift status", NULL},
  { 0x03, END, "Set keyboard typematic rate", NULL},
  { 0x04, END, "Keyboard click adjustment", NULL},
  { 0x05, END, "Keyboard buffer write", NULL},
  { 0x10, END, "Wait for keystroke and read", NULL},
  { 0x11, END, "Get keystroke status", NULL},
  { 0x12, END, "Get shift status", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int17fns[]={
  { 0x00, END, "Print character", NULL},
  { 0x01, END, "Initialize printer port", NULL},
  { 0x02, END, "Read printer port status", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int1afns[]={
  { 0x00, END, "Read system clock counter", NULL},
  { 0x01, END, "Set system clock counter", NULL},
  { 0x02, END, "Read real time clock time", NULL},
  { 0x03, END, "Set real time clock time", NULL},
  { 0x04, END, "Read real time clock date", NULL},
  { 0x05, END, "Set real time clock date", NULL},
  { 0x06, END, "Set real time clock alarm", NULL},
  { 0x07, END, "Reset real time clock alarm", NULL},
  { 0x08, END, "Set RTC activated power on mode", NULL},
  { 0x09, END, "Read RTC alarm time and status", NULL},
  { 0x0a, END, "Read system day counter", NULL},
  { 0x0b, END, "Set system day counter", NULL},
  { 0x80, END, "Set up sound multiplexer", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int2afns[]={
  { 0x00, END, "Network installation query", NULL},
  { 0x01, END, "Execute NETBIOS request with no error retry", NULL},
  { 0x02, END, "Set network printer mode", NULL},
  { 0x03, END, "Check if direct I/O allowed", NULL},
  { 0x04, END, "Execute NETBIOS request", NULL},
  { 0x05, END, "Get network resource information", NULL},
  { 0x06, END, "Network print stream control", NULL},
  { 0x80, END, "begin dos critical section", NULL},
  { 0x80, END, "Begin DOS critical section", NULL},
  { 0x81, END, "end dos critical section", NULL},
  { 0x81, END, "End DOS critical section", NULL},
  { 0x82, END, "end dos critical sections 0 through 7", NULL},
  { 0x82, END, "End DOS critical sections 0 through 7", NULL},
  { 0x84, END, "keyboard busy loop", NULL},
  { 0x84, END, "Keyboard busy loop", NULL},
  { 0x87, END, "begin/end background printing", NULL},
  { 0x87, END, "Critical section", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int2f7a20[]={
  {  0, END, "VLM:Get Call address", NULL},
  {  1, END, "VLM:Get CallA address", NULL},
  {  2, END, "VLM:Get MUX address", NULL},
  {  3, END, "VLM:Get ParseAPI address", NULL},
  {  4, END, "VLM:Get Multicast address", NULL},
  {  5, END, "VLM:INT 24 address", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int2f7a2f[]={
  {0xedc, END, "HRMIB uninstall", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int2f7a4f[]={
  {0x01, END, "SNMP install check", NULL},
  {0x02, END, "SNMP ?", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int2f7aff[]={
  {  0,  END, "TBMI install check", NULL},
  {  1,  END, "TBMI/SHELL install check", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int2f7a[]={
  { 0x00, END,    "IPX install check", NULL},
  { 0x10, END,    "TBMI: Get status", NULL},
  { 0x11, END,    "TBMI: Get int2f handlers", NULL},
  { 0x12, END,    "TBMI: Get int64 handlers", NULL},
  { 0x13, END,    "TBMI: Get int7a handlers", NULL},
  { 0x14, END,    "TBMI: Get Statistics %Rcx", NULL},
  { 0x15, END,    "TBMI: RESET", NULL},
  { 0x16, END,    "TBMI: cx=%Rcx", NULL},
  { 0x17, END,    "TBMI: ?", NULL},
  { 0x18, END,    "TASKID: install check", NULL},
  { 0x19, END,    "TASKID: get int08 handlers", NULL},
  { 0x1a, END,    "TASKID: get int2f handlers", NULL},
  { 0x1b, END,    "TASKID: get diagnostics", NULL},
  { 0x1c, END,    "TBMI11: %Rbp %Rcx:%Rdx", NULL},
  { 0x1d, END,    "TBMI11: ?", NULL},
  { 0x1e, END,    "TBMI11: %Res:%Rsi", NULL},
  { 0x20, REG_BX, int2f7a20, "VLM get hook"},
  { 0x21, END,    "Bcast callback conn=%Rcx", NULL},
  { 0x22, END,    "Bcast/SFT3 %Rdl", NULL},
  { 0x2f, REG_BX, int2f7a2f,    "IPXODI get ???"},
  { 0x40, END,    "TCPIP install check", NULL},
  { 0x41, END,    "TCPIP windows support", NULL},
  { 0x42, END,    "TCPIP(42) get ? hook", NULL},
  { 0x43, END,    "TCPIP(43) get ? hook", NULL},
  { 0x44, END,    "TCPIP(44) get ? hook", NULL},
  { 0x4c, END,    "TCPIP(4c) get ? hook", NULL},
  { 0x4e, END,    "RARPD install check", NULL},
  { 0x4f, REG_BX, int2f7a4f, "RARPD uninstall"},
  { 0x80, END,    "SHELL abnormal exit", NULL},
  { 0x81, END,    "SHELL set int21 handler", NULL},
  { 0x85, END,    "SHELL bcast inform %Rcx", NULL},
  { 0x90, END,    "NETBIOS install check", NULL},
  { 0xa0, END,    "HRMIB", NULL},
  { 0xf0, END,    "DOSNP v1.30 install check", NULL},
  { 0xf1, END,    "NACS install check", NULL},
  { 0xfe, END,    "DOSNP install check", NULL},
  { 0xff, REG_BX, int2f7aff, "int2f7aff"},
  { -1, -1, NULL, NULL}
};

struct textID int2fc0[]={
  { 0x00, END, "LSL/NETWARN install check", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int2fc1[]={
  { 0x00, END, "stpipx install check", NULL},
  { 0x01, END, "stpipx uninstall ", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int2fd8[]={
  { 0x00, END, "NWL CLIENT install check", NULL},
  { 0x56, END, "NWL SERVER get ?", NULL},
  { 0x80, END, "NWL SERVER install check", NULL},
  { 0xc0, END, "NWL NWCACHE/NLCACHE install check", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int2ffns[]={
  { 0x00, END, "PRINT.COM", NULL},
  { 0x01, END, "PRINT.COM", NULL},
  { 0x02, END, "PC LAN", NULL},
  { 0x05, END, "Critical Error handler", NULL},
  { 0x06, END, "ASSIGN", NULL},
  { 0x08, END, "DRIVER.SYS", NULL},
  { 0x10, END, "SHARE", NULL},
  { 0x11, END, "Network redirector %D", NULL},
  { 0x12, END, "internal dos", NULL},
  { 0x13, END, "set DISK irq handler", NULL},
  { 0x14, END, "NLSFUNC", NULL},
  { 0x15, END, "GRAPHICS.COM/CDROM", NULL},
  { 0x16, END, "MS Windows", NULL},
  { 0x17, END, "MS Windows OldAp", NULL},
  { 0x19, END, "SHELLB", NULL},
  { 0x1a, END, "ANSI.SYS", NULL},
  { 0x1b, END, "XMA2EMS.SYS", NULL},
  { 0x2e, END, "Error Translation Tables", NULL},
  { 0x40, END, "MS Windows/OS2", NULL},
  { 0x43, END, "HIMEM.SYS", NULL},
  { 0x48, END, "DOSKEY", NULL},
  { 0x7a, REG_AL, int2f7a, "NetWareMux" },
  { 0xae, END, "Network %D", NULL},
  { 0xb7, END, "APPEND", NULL},
  { 0xc0, REG_AL, int2fc0, "Novell ODI" },
  { 0xc1, REG_AL, int2fc1, "Novell PNW" },
  { 0xd8, REG_AL, int2fd8, "Novell NWLite" },
  { 0xd2, END, "QRAM", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int31fns[]={
  { 0x00, END, "Allocate %Rcx LDT descriptors", NULL},
  { 0x01, END, "Free LDT descriptor %Rbx", NULL},
  { 0x02, END, "Segment %Rbx to descriptor", NULL},
  { 0x03, END, "get next selector inc value", NULL},
  { 0x04, END, "lock selector %Rbx", NULL},
  { 0x05, END, "unlock selector %Rbx", NULL},
  { 0x06, END, "get segment base address of %Rbx", NULL},
  { 0x07, END, "set base address of %Rbx to %Rcx%Rdx", NULL},
  { 0x08, END, "set seg limit of %Rbx to %Rcx%Rdx", NULL},
  { 0x09, END, "set access rights of %Rbx to %Rcl (%Rch) ", NULL},
  { 0x0a, END, "create alias descriptor for %Rbx", NULL},
  { 0x0b, END, "get descriptor for %Rbx in %Res:%Rdi", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int33fns[]={
  { 0x00, END, "Mouse Reset/Get Mouse Installed Flag", NULL},
  { 0x01, END, "Show Mouse Cursor", NULL},
  { 0x02, END, "Hide Mouse Cursor", NULL},
  { 0x03, END, "Get Mouse Position and Button Status", NULL},
  { 0x04, END, "Set Mouse Cursor Position", NULL},
  { 0x05, END, "Get Mouse Button Press Information", NULL},
  { 0x06, END, "Get Mouse Button Release Information", NULL},
  { 0x07, END, "Set Mouse Horizontal Min/Max Position", NULL},
  { 0x08, END, "Set Mouse Vertical Min/Max Position", NULL},
  { 0x09, END, "Set Mouse Graphics Cursor", NULL},
  { 0x0a, END, "Set Mouse Text Cursor", NULL},
  { 0x0b, END, "Read Mouse Motion Counters", NULL},
  { 0x0c, END, "Set Mouse User Defined Subroutine and Input Mask", NULL},
  { 0x0d, END, "Mouse Light Pen Emulation On", NULL},
  { 0x0e, END, "Mouse Light Pen Emulation Off", NULL},
  { 0x0f, END, "Set Mouse Mickey Pixel Ratio", NULL},
  { 0x10, END, "Mouse Conditional OFF", NULL},
  { 0x13, END, "Set Mouse Double Speed Threshold", NULL},
  { 0x14, END, "Swap interrupt subroutines", NULL},
  { 0x15, END, "Get mouse driver state and memory requirements", NULL},
  { 0x16, END, "Save mouse driver state", NULL},
  { 0x17, END, "Restore mouse driver state", NULL},
  { 0x18, END, "Set alternate subroutine call mask and address", NULL},
  { 0x19, END, "Get user alternate interrupt address", NULL},
  { 0x1a, END, "Set mouse sensitivity", NULL},
  { 0x1b, END, "Get mouse sensitivity", NULL},
  { 0x1c, END, "Set mouse interrupt rate", NULL},
  { 0x1d, END, "Set mouse CRT page", NULL},
  { 0x1e, END, "Get mouse CRT page", NULL},
  { 0x1f, END, "Disable mouse driver", NULL},
  { 0x20, END, "Enable mouse driver", NULL},
  { 0x21, END, "Reset mouse software", NULL},
  { 0x22, END, "Set language for messages", NULL},
  { 0x23, END, "Get language number", NULL},
  { 0x24, END, "Get driver version, mouse type & ~IRQ~ number", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int5cfns[]={
  { 0x10, END, "start session with NCB_NAME name (call)", NULL},
  { 0x11, END, "listen for call", NULL},
  { 0x12, END, "end session with NCB_NAME name (hangup)", NULL},
  { 0x14, END, "send data via NCB_LSN", NULL},
  { 0x15, END, "receive data from a session", NULL},
  { 0x16, END, "receive data from any session", NULL},
  { 0x17, END, "send multiple data buffers", NULL},
  { 0x20, END, "send unACKed message (datagram)", NULL},
  { 0x21, END, "receive datagram", NULL},
  { 0x22, END, "send broadcast datagram", NULL},
  { 0x23, END, "receive broadcast datagram", NULL},
  { 0x30, END, "add name to name table", NULL},
  { 0x31, END, "delete name from name table", NULL},
  { 0x32, END, "reset adapter card and tables", NULL},
  { 0x33, END, "get adapter status", NULL},
  { 0x34, END, "status of all sessions for name", NULL},
  { 0x35, END, "cancel", NULL},
  { 0x36, END, "add group name to name table", NULL},
  { 0x48, END, "send data and receive data (LAN Manager NETBEUI.DOS)", NULL},
  { 0x70, END, "unlink from IBM remote program (no F0h function)", NULL},
  { 0x71, END, "send data without ACK", NULL},
  { 0x72, END, "send multiple buffers without ACK", NULL},
  { 0x72, END, "UngermannBass Register (conflicts with above function)", NULL},
  { 0x73, END, "UngermannBass SendNmc", NULL},
  { 0x74, END, "UngermannBass Callniu", NULL},
  { 0x75, END, "UngermannBass Calladdr", NULL},
  { 0x76, END, "UngermannBass Listenaddr", NULL},
  { 0x77, END, "UngermannBass SendPkt", NULL},
//  { 0x78, END, "find name", NULL},
  { 0x78, END, "UngermannBass RcvPkt (conflicts with above function)", NULL},
//  { 0x79, END, "token-ring protocol trace", NULL},
  { 0x79, END, "UngermannBass SendAttn (conflicts with above function)", NULL},
  { 0x7A, END, "UngermannBass RcvAttn", NULL},
  { 0x7B, END, "UngermannBass Listenniu", NULL},
  { 0x7C, END, "UngermannBass RcvRaw", NULL},
  { 0x7D, END, "UngermannBass SendNmc2", NULL},
  { 0x7F, END, "Beame&Whiteside BWNB installation check", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int67fns[]={
  { 0x40, END, "Get EMM Status", NULL},
  { 0x41, END, "Get Page Frame Base Address", NULL},
  { 0x42, END, "Get Page Counts", NULL},
  { 0x43, END, "Get Handle and Allocate Pages", NULL},
  { 0x44, END, "Map Logical Page Into Physical Page Window", NULL},
  { 0x45, END, "Release Handle and Memory Pages", NULL},
  { 0x46, END, "Get EMM Version", NULL},
  { 0x47, END, "Save Page Map Context", NULL},
  { 0x48, END, "Restore Page Map Context", NULL},
  { 0x49, END, "Get I/O Port Addresses", NULL},
  { 0x4a, END, "Get Logical to Physical Page Mapping", NULL},
  { 0x4b, END, "Get Handle Count", NULL},
  { 0x4c, END, "Get Page Count for Handle", NULL},
  { 0x4d, END, "Get Page Count for All Handles", NULL},
  { 0x4e, END, "Get/Set Page Map Context", NULL},
  { 0x4f, END, "Get/Set Partial Page Map", NULL},
  { 0x50, END, "Map/Unmap Multiple Handle Pages", NULL},
  { 0x51, END, "Reallocate Pages", NULL},
  { 0x52, END, "Get/Set Handle Attributes", NULL},
  { 0x53, END, "Get/Set Handle Name", NULL},
  { 0x54, END, "Get Handle Directory", NULL},
  { 0x55, END, "Alter Page Map and Jump", NULL},
  { 0x56, END, "Alter Page Map and Call", NULL},
  { 0x57, END, "Move/Exchange Memory Region", NULL},
  { 0x58, END, "Get Mappable Physical Address Array", NULL},
  { 0x59, END, "Get Expanded Memory Hardware Information", NULL},
  { 0x5a, END, "Allocate Standard/Raw Pages", NULL},
  { 0x5b, END, "Alternate Map Register Set DMA Registers", NULL},
  { 0x5c, END, "Prepare Expanded Memory for Warm Boot", NULL},
  { 0x5d, END, "Enable/Disable OS Functions", NULL},
  { 0x60, END, "Get Physical Window Array", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int21f2[]={     // NCP names
// 0x00
 { 0x01, END, "File Set Lock", NULL},
 { 0x02, END, "File Release Lock", NULL},
 { 0x03, END, "Log File(old)", NULL},
 { 0x04, END, "Lock File Set(old)", NULL},
 { 0x05, END, "Release File", NULL},
 { 0x06, END, "Release File Set", NULL},
 { 0x07, END, "Clear File", NULL},
 { 0x08, END, "Clear File Set", NULL},
 { 0x09, END, "Log Logical Record(old)", NULL},
 { 0x0a, END, "Lock Logical Record Set(old)", NULL},
 { 0x0b, END, "Clear Logical Record", NULL},
 { 0x0c, END, "Release Logical Record", NULL},
 { 0x0d, END, "Release Logical Record Set", NULL},
 { 0x0e, END, "Clear Logical Record Set", NULL},
 { 0x0f, END, "Allocate Resource", NULL},
 { 0x10, END, "Deallocate Resource", NULL},
 { 0x11, OFFSET+2, NCP11fns, "NWprinter"},           //  ---- Print Services
 { 0x12, END, "Get Volume Info with Number", NULL},
 { 0x13, END, "Get Station Number", NULL},
 { 0x14, END, "Get File Server Date And Time", NULL},
 { 0x15, OFFSET+2, NCP15fns, "NWMessage"},           //  ---- Message Services
 { 0x16, OFFSET+2, NCP16fns, "NWDirectory"},  //  ---- Directory Services
 { 0x17, OFFSET+2, NCP17fns, "NWBindery/conn"},  //  ---- Bindery And Misc Services
 { 0x18, END, "End Of Job", NULL},
 { 0x19, END, "Logout", NULL},
 { 0x1a, END, "Log Physical Record(old)", NULL},
 { 0x1b, END, "Lock Physical Record Set(old)", NULL},
 { 0x1c, END, "Release Physical Record", NULL},
 { 0x1d, END, "Release Physical Record Set", NULL},
 { 0x1e, END, "Clear Physical Record", NULL},
 { 0x1f, END, "Clear Physical Record Set", NULL},
 { 0x20, OFFSET+0, NCP20fns, "NWSemaphore"},  //  ---- Semaphore Services(old)
 { 0x21, END, "Negotiate Buffer Size", NULL},
 { 0x22, OFFSET+0, NCP22fns, "NWTTS"},  //  ---- Transaction Tracking Services
 { 0x23, OFFSET+2, NCP23fns, "NWAFP"},  //  ---- AFP Services
 { 0x24, END, "Clear Record", NULL},
 { 0x25, END, "25- unknown (3.x)", NULL},
// 0x26  unused
// 0x27  unused
// 0x28  unused
// 0x29  unused
// 0x2a  unused
// 0x2b  unused
// 0x2c  unused
// 0x2d  unused
// 0x2e  unused
// 0x2f  unused
// 0x30  unused
// 0x31  unused
// 0x32  unused
// 0x33  unused
// 0x34  unused
// 0x35  unused
// 0x36  unused
// 0x37  unused
// 0x38  unused
// 0x39  unused
// 0x3a  unused
 { 0x3b, END, "3b- unknown (3.x)", NULL},
 { 0x3c, END, "Dup Handle", NULL},
 { 0x3d, END, "Commit File", NULL},
 { 0x3e, END, "File Search Initialize", NULL},
 { 0x3f, END, "File Search Continue", NULL},
 { 0x40, END, "Search For A File", NULL},
 { 0x41, END, "Open File OLD", NULL},
 { 0x42, END, "Close File", NULL},
 { 0x43, END, "Create File", NULL},
 { 0x44, END, "Erase File", NULL},
 { 0x45, END, "Rename File", NULL},
 { 0x46, END, "Set File Attributes", NULL},
 { 0x47, END, "Get Current File Size", NULL},
 { 0x48, END, "Read File", NULL},
 { 0x49, END, "Write File", NULL},
 { 0x4a, END, "Server File Copy", NULL},
 { 0x4b, END, "Set File Time Date Stamp", NULL},
 { 0x4c, END, "Open File", NULL},
 { 0x4d, END, "Create New File", NULL},
 { 0x4e, END, "Allow Task Access To File", NULL},
 { 0x4f, END, "Set File Extended Attributes", NULL},
// 0x50  unused
// 0x51  unused
// 0x52  unused
// 0x53  unused
 { 0x54, END, "Open Create File", NULL},
 { 0x55, END, "Get Sparse File Bit Map", NULL},
 { 0x56, OFFSET+0, NCP56fns, "NWExtended Attributes"},  //  ---- Extended Attribute Services
 { 0x57, OFFSET+0, NCP57fns, "NWEnhanced NCP"},  //  ---- Enhanced NCP Services
 { 0x58, OFFSET+0, NCP58fns, "NWAuditing"},  //  ---- NetWare Auditing (4.x only)
// 0x59  unused
 { 0x5a, OFFSET+2, NCP5afns, "NWMigration"},  //  ---- Migration Services (4.x only)
// 0x5b  unused
// 0x5c  unused
// 0x5d  unused
// 0x5e  unused
// 0x5f  unused
 { 0x60, OFFSET+0, NCP60fns, "PNW"},  //  ---- PNW Specific
 { 0x61, END, "Get Big Packet NCP Max Packet Size", NULL},
 { 0x62, END, "Data Echo", NULL},
 { 0x63, END, "Next Big Write", NULL},
 { 0x64, END, "Big Read", NULL},
 { 0x65, END, "Packet Burst Connection", NULL},
 { 0x66, END, "Big ReRead", NULL},
 { 0x67, END, "Big Write", NULL},
 { 0x68, OFFSET+0, NCP68fns, "NW NDS"},  //  ---- NetWare Directory Services (4.x only)
 { 0x69, END, "Log File(new)", NULL},
 { 0x6a, END, "Lock File Set(new)", NULL},
 { 0x6b, END, "Log Logical Record(new)", NULL},
 { 0x6c, END, "Lock Logical Record Set(new)", NULL},
 { 0x6d, END, "Log Physical Record(new)", NULL},
 { 0x6e, END, "Lock Physical Record Set(new)", NULL},
 { 0x6f, OFFSET+0, NCP6ffns, "NW new Semaphores"},  //  ---- Semaphore services(new)
 { 0x70, END, "Clear And Get Wait Lock Comp", NULL},
// 0x71  unused
 { 0x72, END, "Time Sync Request (4.x only)", NULL},
// 0x73  unused
// 0x74  unused
// 0x75  unused
// 0x76  unused
// 0x77  unused
// 0x78  unused
// 0x79  unused
// 0x7a  unused
 { 0x7b, OFFSET+2, NCP7bfns, "NW FS information"},  //  ---- FS info NetWare 4.0 only
// 0x7c  unused
// 0x7d  unused
// 0x7e  unused
// 0x7f  unused
 { -1, -1, NULL, NULL}
};

struct textID int21b3[]={  // == vlmcall(NWP, 0x10), AX=sub
  { 0x00, END, "Check LIP/NCP signatures/IPX Checksum Support",NULL},
  { 0x01, END, "Check NCP signature level", NULL},
  { 0x02, END, "Start packet signing", NULL},     // create session key
  { 0x03, END, "update signature", NULL},
  { 0x04, END, "Set signature level", NULL},
  { 0x05, END, "Get Connection Status", NULL},
  { 0x06, END, "negotiate signature level", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int21b5[]={
  { 0x00, END, "Get Instance Data", NULL},
  { 0x01, END, "End Virtual Machine", NULL},
  { 0x02, END, "Start Virtual Machine", NULL},
  { 0x03, END, "Get Task Mode", NULL},
  { 0x04, END, "Get Task Mode Pointer", NULL},
  { 0x05, END, "Set Virtual Machine ID", NULL},
  { 0x06, END, "Get Virtual Mach Support Level", NULL},
  { 0x07, END, "Get Number Of Packet Burst Buffers", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int21b6[]={
  { 0x00, END, "Get Extended File Attributes", NULL},
  { 0x01, END, "Set Extended File Attributes to %Rcl file %Rds:%Rdx", NULL},
  { 0x00, END, "", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int21b8[]={
  { 0x00, END, "Get Default Capture flags", NULL},
  { 0x01, END, "Set Default Capture flags", NULL},
  { 0x02, END, "Get Specific Capture flags", NULL},
  { 0x03, END, "Set Specific Capture flags LPT%Rdh", NULL},
  { 0x04, END, "Get Default Local Printer", NULL},
  { 0x05, END, "Set Default Local Printer LPT%Rdh", NULL},
  { 0x06, END, "Set Capture Print Queue LPT%Rdh queue=%Rbx%Rcx", NULL},
  { 0x07, END, "Set Capture Print Job LPT%Rdh job %Rbx", NULL},
  { 0x08, END, "Get Banner user name", NULL},
  { 0x09, END, "Set Banner user name to %Res:%Rbx", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int21c5[]={
  { 0x00, END, "Open Semaphore val=%Rcl", NULL},  // name=DSDX
  { 0x01, END, "examine semaphore %Rcx%Rdx", NULL},
  { 0x02, END, "wait on semaphore %Rcx%Rdx", NULL},
  { 0x03, END, "signal semaphore %Rcx%Rdx", NULL},
  { 0x04, END, "close semaphore %Rcx%Rdx", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int21c6[]={
  { 0x00, END, "Set Compatibility lock mode", NULL},
  { 0x01, END, "Set new extended lock mode", NULL},
  { 0x02, END, "Get lock mode", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int21c7[]={
  { 0x00, END, "TTS Begin Transaction", NULL},
  { 0x01, END, "TTS End Transaction %Rcx:%Rdx", NULL},
  { 0x02, END, "TTS install check", NULL},
  { 0x03, END, "TTS Abort Transaction %Rcx:%Rdx", NULL},
  { 0x04, END, "TTS Transaction Status %Rcx:%Rdx", NULL},
  { 0x05, END, "Get application thresholds", NULL},
  { 0x06, END, "Set application thresholds", NULL},
  { 0x07, END, "Get Workstation thresholds", NULL},
  { 0x08, END, "Set Workstation thresholds", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int21de[]={
  { 0x00, END, "Bcast mode: Receive Server & workstation messages", NULL},
  { 0x01, END, "Bcast mode: Receive Server messages", NULL},
  { 0x02, END, "Bcast mode: Store Server messages", NULL},
  { 0x03, END, "Bcast mode: Store Server & workstation messages", NULL},
  { 0x04, END, "Get Broadcast mode", NULL},
  { 0x05, END, "disable shell timer int checks", NULL},
  { 0x06, END, "enable shell timer int checks", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int21df[]={
  { 0x00, END, "Start LPT capture", NULL},
  { 0x01, END, "End LPT capture", NULL},
  { 0x02, END, "Cancel LPT capture", NULL},
  { 0x03, END, "Flush LPT capture", NULL},
  { 0x04, END, "Start capture LPT%Rdh", NULL},
  { 0x05, END, "End capture LPT%Rdh", NULL},
  { 0x06, END, "Cancel capture LPT%Rdh", NULL},
  { 0x07, END, "Flush capture LPT%Rdh", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int21e9[]={
  { 0x00, END, "Get Directory handle for drive %Rdx", NULL},
  { 0x05, END, "Map root directory drive %Rbl path=%Rds:%Rbx", NULL},
  { 0x06, END, "Delete root mapping drive %Rbl", NULL},
  { 0x07, END, "Get drive depth for drive %Rbl", NULL},
  { 0x08, END, "set show dots %Rbl", NULL},
  { 0x09, END, "doshandle %Rbx to netware handle ", NULL},
  { 0x00, END, "", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int21fns[]={
//  0x61  - unused
  { 0x45, END, "'dup' - duplicate file handle", NULL},
  { 0x46, END, "'dup2', 'forcedup' - force duplicate file handle", NULL},
  { 0x68, END, "'fflush' - commit file", NULL},
  { 0x52, END, "'sysvars' - get list of lists", NULL},
  { 0x48, END, "allocate memory", NULL},
  { 0xd8, END, "Allocate Resource %Rdl", NULL},
  { 0xb4, END, "Attach Handle", NULL},
  { 0xc8, END, "Begin Logical File Locking mode=%Rdl  timeout=%Rbp", NULL},
  { 0x0a, END, "buffered input", NULL},
  { 0x08, END, "character input without echo", NULL},
  { 0x3b, END, "chdir %D", NULL},
  { 0xed, END, "Clear file %Rds:%Rdx", NULL},
  { 0xce, END, "Clear File FCB=%Rds:%Rdx", NULL},
  { 0xcf, END, "Clear File Set", NULL},
  { 0xd4, END, "Clear logical Record %Rds:%Rdx", NULL},
  { 0xd5, END, "Clear logical Record Set", NULL},
  { 0xbe, END, "Clear Physical Record file=%Rbx off=%Rcx%Rdx l=%Rsi%Rdi", NULL},
  { 0xc1, END, "Clear Record FCB=%Rds:%Rdx off=%Rbx%Rcx", NULL},
  { 0xc4, END, "Clear Record set",  NULL},
  { 0x10, END, "close file using fcb", NULL},
  { 0x3e, END, "close handle=%Rbx", NULL},
  { 0x6a, END, "commit file", NULL},
  { 0xe6, END, "Copy file FCB=%Rds:%Rsi to %Res:%Rdi len=%Rcx%Rdx", NULL},
  { 0x3c, END, "creat attrib=%Rcx %D", NULL},
  { 0x55, END, "create child psp", NULL},
  { 0x26, END, "create new program segment prefix", NULL},
  { 0x5b, END, "creatnew attrib=%Rcx %D", NULL},
  { 0x5a, END, "creattmp attrib=%Rcx %D", NULL},
  { 0xd9, END, "DeAllocate Resource %Rdl", NULL},
  { 0x44, END, "device ioctl", NULL},
  { 0x07, END, "direct character input, without echo", NULL},
  { 0x0d, END, "disk reset", NULL},
  { 0xc9, END, "End Logical File Locking", NULL},
  { 0xd6, END, "End Of Job", NULL},
  { 0x4b, END, "exec subfn=%Ral, %D", NULL},              // SUB!!!
  { 0x4c, END, "exit err %Ral", NULL},
  { 0x6c, END, "extended open al=%Ral mode=%Rbl flags=%Rbh attr=%Rcx action=%Rdx %D", NULL},
  { 0x63, END, "fareast double byte chars", NULL},
  { 0x43, END, "fattr fn=%Ral, attrib=%Rcx  %D", NULL},  // SUB!!!
  { 0x16, END, "FCB create %D", NULL},
  { 0x13, END, "FCB delete %D", NULL},
  { 0x11, END, "FCB findfirst %D", NULL},
  { 0x12, END, "FCB findnext %D", NULL},
  { 0x23, END, "FCB getsize %D", NULL},
  { 0x0f, END, "FCB open %D", NULL},
  { 0x17, END, "FCB rename %D", NULL}, // 2 FCBname
  { 0xf3, END, "Fileserver FileCopy buf=%Res:%Rdi", NULL},
  { 0x6d, END, "find first rom program", NULL},
  { 0x6e, END, "find next rom program", NULL},
  { 0x4e, END, "findfirst attrib=%Rcx %D", NULL},
  { 0x4f, END, "findnext %D", NULL},
  { 0x0c, END, "flush buffer and read standard input", NULL},
  { 0x49, END, "free memory", NULL},
  { 0x34, END, "get address of indos flag", NULL},
  { 0x1b, END, "get allocation information for default drive", NULL},
  { 0x1c, END, "get allocation information for specific drive", NULL},
  { 0xdc, END, "Get Connection Number", NULL},
  { 0x51, END, "get current process id (get psp address)", NULL},
  { 0x62, END, "get current psp address", NULL},
  { 0x2f, END, "get disk transfer area address", NULL},
  { 0x32, END, "get dos drive parameter block for specific drive", NULL},
  { 0x30, END, "get dos version", NULL},
  { 0x1f, END, "get drive parameter block for default drive", NULL},
  { 0x65, END, "get extended country information/char handling", NULL},
  { 0x59, END, "get extended error information", NULL},
  { 0xe7, END, "Get File Server Date & Time", NULL},
  { 0x36, END, "get free disk space", NULL},
  { 0xdb, END, "Get Number of local drives", NULL},
  { 0xee, END, "Get physical station address", NULL},
  { 0x4d, END, "get return code (errorlevel)", NULL},
  { 0xea, END, "Get Shell Version flg=%Ral", NULL},
  { 0x0b, END, "get stdin status", NULL},
  { 0x2a, END, "get system date", NULL},
  { 0x2c, END, "get system time", NULL},
  { 0x60, END, "get truename %D", NULL},
  { 0x35, END, "get vector int %Ral", NULL},
  { 0x54, END, "get verify flag", NULL},
  { 0xda, END, "Get Volume info for %Rdl in %Res:%Rdi", NULL},
  { 0x33, END, "get/set break checking", NULL},
  { 0x38, END, "get/set country-specific information", NULL},
  { 0x69, END, "get/set disk serial number", NULL},
  { 0x57, END, "get/set file dat/time/attribs", NULL},
  { 0x66, END, "get/set global code page table", NULL},
  { 0x58, END, "get/set memory alloc strategy", NULL},
  { 0x6f, END, "get/set rom scan start address", NULL},
  { 0x37, END, "get/set switchchar", NULL},
  { 0x47, END, "getcwd drive=%Rdl", NULL},
  { 0x19, END, "getdrv", NULL},
  { 0xb7, END, "HoldFilemodeSet", NULL},
  { 0xcb, END, "Lock File Set mode=%Rdl, timeout=%Rbp", NULL},
  { 0x5c, END, "lock fn=%Ral handle=%Rbx offset=%Rcx%Rdx len=%Rsi%Rdi", NULL},
  { 0xca, END, "Lock Personal File, flag=%Ral, timeout=%Rbp FCB=%Rds:%Rdx", NULL},
  { 0xeb, END, "Log file %Rds:%Rdx flags=%Ral", NULL},
  { 0xd0, END, "Log logical Record %Rds:%Rdx flags=%Ral timeout=%Rbp", NULL},
  { 0xd1, END, "Log logical Record Set type=%Ral mode=%Rdl timeout=%Rbp", NULL},
  { 0xbc, END, "Log Physical Record flag=%Ral file=%Rbx timeout=%Rbp off=%Rcx%Rdx l=%Rsi%Rdi", NULL},
  { 0xbf, END, "Log Record flags=%Ral FCB=%Rds:%Rdx timeout=%Rbp off=%Rbx%Rcx l=%Rsi%Rdi", NULL},
  { 0xc2, END, "Log Record set flags=%Ral timeout=%Rbp", NULL},
  { 0xd7, END, "Logout", NULL},
  { 0x42, END, "lseek from=%Ral handle=%Rbx offset=%Rcx%Rdx", NULL},
  { 0x39, END, "mkdir %D", NULL},
  { 0x5e, END, "network stuff", NULL},
  { 0x18, END, "null function for cp/m compatibility", NULL},
  { 0x1d, END, "null function for cp/m compatibility", NULL},
  { 0x1e, END, "null function for cp/m compatibility", NULL},
  { 0x20, END, "null function for cp/m compatibility", NULL},
  { 0x6b, END, "null function", NULL},
  { 0x3d, END, "open mode=%Ral, %D", NULL},
  { 0x29, END, "parse filename %D", NULL},
  { 0x04, END, "putc aux %D", NULL},
  { 0x06, END, "putc con %D", NULL},
  { 0x05, END, "putc prn %D", NULL},
  { 0x09, END, "puts ASCII$ %D", NULL},
  { 0x27, END, "random block read from fcb file", NULL},
  { 0x28, END, "random block write to fcb file", NULL},
  { 0x03, END, "read character from aux", NULL},
  { 0x01, END, "read character from stdin, with echo", NULL},
  { 0x3f, END, "read handle=%Rbx, buf=%Rds:%Rdx len=%Rcx", NULL},
  { 0x21, END, "read random record from fcb file", NULL},
  { 0xec, END, "Release file %Rds:%Rdx", NULL},
  { 0xcc, END, "Release File FCB=%Rds:%Rdx", NULL},
  { 0xcd, END, "Release File Set", NULL},
  { 0xd2, END, "Release logical Record %Rds:%Rdx", NULL},
  { 0xd3, END, "Release logical Record Set", NULL},
  { 0xbd, END, "Release Physical Record file=%Rbx off=%Rcx%Rdx l=%Rsi%Rdi", NULL},
  { 0xc0, END, "Release Record FCB=%Rds:%Rdx off=%Rbx%Rcx", NULL},
  { 0xc3, END, "Release Record set", NULL},
  { 0x56, END, "rename %D", NULL},  // 2 strings
  { 0x4a, END, "resize memory block", NULL},
  { 0xba, END, "ReturnCommandComPointers", NULL},
  { 0x3a, END, "rmdir %D", NULL},
  { 0x14, END, "sequential read from fcb file", NULL},
  { 0x15, END, "sequential write to fcb file", NULL},
  { 0x50, END, "set current process id (set psp address)", NULL},
  { 0x64, END, "set device driver lookahead flag", NULL},
  { 0x1a, END, "set disk transfer area address", NULL},
  { 0xbb, END, "Set End Of Job Status %Ral", NULL},
  { 0xe8, END, "Set FCB re-open mode to %Rdl", NULL},
  { 0xe4, END, "Set File Attributes FCB=%Rds:%Rdx attr=%Rcl", NULL},
  { 0x67, END, "set handle count", NULL},
  { 0xdd, END, "Set NW Error mode to %Rdl", NULL},
  { 0x24, END, "set random record number for fcb", NULL},
  { 0x2b, END, "set system date", NULL},
  { 0x2d, END, "set system time", NULL},
  { 0x25, END, "set vector int %Ral = %Rds:%Rdx", NULL},
  { 0x2e, END, "set verify flag", NULL},
  { 0x0e, END, "setdrv to %Rdl", NULL},
  { 0x5d, END, "share/network stuff", NULL},
  { 0xb9, END, "SpecialAttachableFunction", NULL},
  { 0x02, END, "stdout %D", NULL},
  { 0x00, END, "terminate program", NULL},
  { 0x53, END, "translate bios parameter block to drive param block", NULL},
  { 0x31, END, "tsr err %Ral resident paragraphs %Rdx", NULL},
  { 0x41, END, "unlink %D", NULL},
  { 0x40, END, "write handle=%Rbx, buf=%Rds:%Rdx len=%Rcx", NULL},
  { 0x22, END, "write random record to fcb file", NULL},
  { 0xe0, OFFSET, NCP11fns,                "NW printer"},   // nw printer
  { 0xe1, OFFSET, NCP15fns,                "NW message"},   // nw message
  { 0xe2, OFFSET, NCP16fns,                "NW directory"},   // nw directory
  { 0xe3, OFFSET, NCP17fns,                "NW bindery/connect"},   // nw bindery/connect
  { 0xef, REG_AL,   int21ef,               "NW workstation"}, // nw workstation
  { 0xf0, REG_AL,   int21f0,               "NW connection (con=%Rdl)"}, // nw connection
  { 0xf1, REG_AL,   int21f1,               "NW attach (con=%Rdl)"}, // nw attach
  { 0xf2, REG_AL,   int21f2,               "NW NCP"}, // nw ncp request
  { 0x5f, REG_AL, int215f, "Network redir"},  // network redir
  { 0xb3, REG_AL, int21b3, "NCP signatures"},

  { 0xb5, REG_AL, int21b5, "task mode control"},
  { 0xb6, REG_AL, int21b6, "extended attributes"},
  { 0xb8, REG_AL, int21b8, "Print Services"},
  { 0xc5, REG_AL, int21c5, "NW Semaphores"},
  { 0xc6, REG_AL, int21c6, "NW lock mode"},
  { 0xc7, REG_AL, int21c7, "NW Transaction tracking"},
  { 0xdf, REG_AL, int21df, "Print services"},
  { 0xe9, REG_AL, int21e9, "Directory services"},
  { 0xde, REG_DL, int21de, "Message services"},
  { -1, -1, NULL, NULL}
};

struct textID int7afns[]={
  { 0x00, END, "IPX Open Socket %Rdx  type=%Ral", NULL},
  { 0x01, END, "IPX Close Socket %Rdx", NULL},
  { 0x02, END, "IPX Get Local Target", NULL},
  { 0x03, END, "IPX Send Packet ecb=%Res:%Rsi", NULL},
  { 0x04, END, "IPX Listen For Packet ecb=%Res:%Rsi", NULL},
  { 0x05, END, "IPX Schedule IPX Event delay=%Rax ecb=%Res:%Rsi", NULL},
  { 0x06, END, "IPX Cancel Event", NULL},
  { 0x07, END, "IPX Schedule AES Event delay=%Rax ecb=%Res:%Rsi", NULL},
  { 0x08, END, "IPX Get Interval Marker", NULL},
  { 0x09, END, "IPX Get Internetwork Address", NULL},
  { 0x0a, END, "IPX Relinquish Control", NULL},
  { 0x0b, END, "IPX Disconnect From Target", NULL},
  { 0x0c, END, "IPX Initialize Network Address net=%Rcx%Rdx", NULL},
  { 0x0d, END, "IPX Get Packet Size size=%Rax retry=%Rcx", NULL},
  { 0x0e, END, "IPX Terminate Sockets", NULL},
  { 0x0f, END, "IPX Fast Send Packet", NULL},
  { 0x10, END, "SPX Initialize", NULL},
  { 0x11, END, "SPX Establish Connection", NULL},
  { 0x12, END, "SPX Listen For Connection", NULL},
  { 0x13, END, "SPX Terminate Connection", NULL},
  { 0x14, END, "SPX Abort Connection", NULL},
  { 0x15, END, "SPX Get Connection Status", NULL},
  { 0x16, END, "SPX Send Sequenced Packet", NULL},
  { 0x17, END, "SPX Listen For Sequenced Packet", NULL},
  { 0x18, END, "SPX Add Diagnostic Element", NULL},
  { 0x19, END, "SPX Cancel Diagnostic Element", NULL},
  { 0x1a, END, "IPX Get Max Packet Size", NULL},
  { 0x1f, END, "Get IPX Information", NULL},
  { 0x20, END, "IPX Send With Checksum ecb=%Res:%Rsi", NULL},
  { 0x21, END, "IPX Generate Checksum", NULL},
  { 0x22, END, "IPX Verify Checksum ecb=%Res:%Rsi", NULL},
  { 0x23, END, "IPX Open Look Ahead Socket %Rdx size=%Rbp handler=%Res:%Rsi", NULL},
  { 0x24, END, "IPX Set Internetwork Address", NULL},
  { -1, -1, NULL, NULL}
};

struct textID int7bfns[]={
  { 0x00, END, "open", NULL},
  { 0x01, END, "close", NULL},
  { 0x02, END, "insert", NULL},
  { 0x03, END, "update", NULL},
  { 0x04, END, "delete", NULL},
  { 0x05, END, "get_equal", NULL},
  { 0x06, END, "get_next", NULL},
  { 0x07, END, "get_prev", NULL},
  { 0x08, END, "get_greater", NULL},
  { 0x09, END, "get_gr_eql", NULL},
  { 0x0A, END, "get_less", NULL},
  { 0x0B, END, "get_less_eq", NULL},
  { 0x0C, END, "get_first", NULL},
  { 0x0D, END, "get_last", NULL},
  { 0x0E, END, "create", NULL},
  { 0x0F, END, "stat", NULL},
  { 0x10, END, "extend", NULL},
  { 0x11, END, "set_dir", NULL},
  { 0x12, END, "get_dir", NULL},
  { 0x13, END, "begin_trans", NULL},
  { 0x14, END, "end_trans", NULL},
  { 0x15, END, "abort_trans", NULL},
  { 0x16, END, "get_pos", NULL},
  { 0x17, END, "get_direct", NULL},
  { 0x18, END, "step_next", NULL},
  { 0x19, END, "stop", NULL},
  { 0x1A, END, "version", NULL},
  { 0x1B, END, "unlock", NULL},
  { 0x1C, END, "reset", NULL},
  { 0x1D, END, "set owner", NULL},
  { 0x1E, END, "clear owner", NULL},
  { 0x1F, END, "create supplemental index", NULL},
  { 0x20, END, "drop supplemental index", NULL},
  { 0x21, END, "step first", NULL},
  { 0x22, END, "step last", NULL},
  { 0x23, END, "step previous", NULL},
  { 0x24, END, "get next extended", NULL},
  { 0x25, END, "get previous extended", NULL},
  { 0x26, END, "step next extended", NULL},
  { 0x27, END, "step previous extended", NULL},
  { 0x28, END, "insert extended", NULL},
  { -1, -1, NULL, NULL}
};

struct textID interrupts[]={
       { 0x00, END, "CPU:divide by zero", NULL},
       { 0x01, END, "CPU:single step", NULL},
       { 0x02, END, "CPU:non-maskable", NULL},
       { 0x03, END, "CPU:breakpoint", NULL},
       { 0x04, END, "CPU:overflow trap", NULL},
       { 0x05, END, "print screen", NULL},
       { 0x06, END, "CPU:Invalid opcode", NULL},
       { 0x07, END, "CPU:coprocessor not available", NULL},
       { 0x08, END, "IRQ0:timer", NULL},
       { 0x09, END, "IRQ1:keyboard", NULL},
       { 0x0a, END, "IRQ2:slave 8259 or EGA/VGA vertical retrace", NULL},
       { 0x0b, END, "IRQ3:COM2", NULL},
       { 0x0c, END, "IRQ4:COM1", NULL},
       { 0x0d, END, "IRQ5:LPT2 / XT fixed disk", NULL},
       { 0x0e, END, "IRQ6:floppy disk", NULL},
       { 0x0f, END, "IRQ7:LPT1", NULL},
       { 0x10, REG_AH, int10fns, "Video"},          // video
       { 0x11, END, "Get Equipment", NULL},
       { 0x12, END, "Get memory size", NULL},
       { 0x13, REG_AH, int13fns, "disk I/O"},          // disk I/O service
       { 0x14, REG_AH, int14fns, "serial comm"},          // serial communications
       { 0x15, REG_AH, int15fns, "system services, cassette"},          // system services, cassette
       { 0x16, REG_AH, int16fns, "keyboard"},          // keyboard services
       { 0x17, REG_AH, int17fns, "parallel printer"},          // parallel printer
       { 0x18, END, "ROM BASIC loader", NULL},
       { 0x19, END, "bootstrap loader", NULL},
       { 0x1a, REG_AH, int1afns, "time of day"},          // time of day
       { 0x1b, END, "user defined ctrl-break handler", NULL},
       { 0x1c, END, "user defined clock tick handler", NULL},
       { 0x1d, END, "~6845~ video parameter pointer", NULL},   // not an int
       { 0x1e, END, "diskette parameter pointer", NULL},       // not an int
       { 0x1f, END, "graphics character table", NULL},         // not an int
       { 0x20, END, "general program termination",  NULL},
       { 0x21, REG_AH, int21fns, "DOS"},                       // DOS functions
       { 0x22, END, "terminate address", NULL},
       { 0x23, END, "control break termination address", NULL},
       { 0x24, END, "critical error handler", NULL},
       { 0x25, END, "absolute disk read", NULL},
       { 0x26, END, "absolute disk write", NULL},
       { 0x27, END, "terminate and stay resident", NULL},
       { 0x28, END, "idle loop, issued by DOS when idle", NULL},
       { 0x29, END, "fast TTY console I/O", NULL},
       { 0x2a, REG_AH, int2afns, "netbios, critical section"},  // critical section and NETBIOS
//       0x2b, END, "??", NULL,
//       0x2c, END, "??", NULL,
//       0x2d, END, "??", NULL,
       { 0x2e, END, "exec command from base level command interpreter", NULL},
       { 0x2f, REG_AH, int2ffns, "multiplexer ax=%Rax bx=%Rbx"},           // multiplexer
       { 0x30, END, "CPM far jump vector", NULL}, // not an interrupt
       { 0x31, REG_AX, int31fns, "DPMI"},           // DPMI - dos extender
//       0x32              reserved ,
       { 0x33, REG_AX, int33fns, "mouse"},           // mouse support
       { 0x34, END, "FP emu opcode d8", NULL},
       { 0x35, END, "FP emu opcode d9", NULL},
       { 0x36, END, "FP emu opcode da", NULL},
       { 0x37, END, "FP emu opcode db", NULL},
       { 0x38, END, "FP emu opcode dc", NULL},
       { 0x39, END, "FP emu opcode dd", NULL},
       { 0x3a, END, "FP emu opcode de", NULL},
       { 0x3b, END, "FP emu opcode df", NULL},
       { 0x3c, END, "FP emu fpseg", NULL},     // param ss011xxx -> 0ss00110 11011xxx
       { 0x3d, END, "FP emu fpwait", NULL},
       { 0x3e, END, "FP emu shortcut", NULL},
       { 0x3f, END, "overlay manager", NULL},
       { 0x40, REG_AH, int13fns, "fdc int40"},          // link from int13
       { 0x41, END, "fixed disk 0 parameters pointer", NULL}, // not an int
       { 0x42, REG_AH, int10fns, "video int42"},          // link from int10
       { 0x43, END, "user font table", NULL},       // not an int
       { 0x44, END, "first 128 graphics characters", NULL}, // not an int
//       0x45      BIOS    reserved for BIOS
       { 0x46, END, "fixed disk 1 parameters pointer", NULL}, // not an int
//       0x47      BIOS    reserved for BIOS
       { 0x48, END, "PCjr cordless keyboard translation", NULL},
       { 0x49, END, "PCjr non-keyboard scancode translation table", NULL},
       { 0x4a, END, "user alarm", NULL},
//       0x4b      BIOS    reserved
//       0x4c      BIOS    reserved
//       0x4d      BIOS    reserved
//       0x4e      BIOS    reserved
//       0x4f      BIOS    reserved
       { 0x50, END, "periodic alarm from timer", NULL},
//       0x51      BIOS    reserved
//       0x52      BIOS    reserved
//       0x53      BIOS    reserved
//       0x54      BIOS    reserved
//       0x55      BIOS    reserved
//       0x56      BIOS    reserved
//       0x57      BIOS    reserved
//       0x58      BIOS    reserved
//       0x59      BIOS    GSS Computer Graphics Interface
//       0x5a      BIOS    cluster adapter BIOS entry point
//       0x5b      BIOS    cluster adapter boot
       { 0x5c, OFFSET+0, int5cfns, "netbios/tops"},   //  NETBIOS interface, TOPS interface
//       0x5d      BIOS    reserved for BIOS
//       0x5e      BIOS    reserved for BIOS
//       0x5f      BIOS    reserved for BIOS
//       0x60              reserved for user software interrupts
//       0x61              reserved for user software interrupts
//       0x62              reserved for user software interrupts
//       0x63              reserved for user software interrupts
//       0x64              reserved for user software interrupts
//       0x65              reserved for user software interrupts
//       0x66              reserved for user software interrupts
       { 0x67, END, int67fns, NULL},      // LIM/EMS specification
//       0x68              APPC
//       0x69              reserved by IBM
//       0x6a              reserved by IBM
//       0x6b              reserved by IBM
       { 0x6c, END, "DOS 3.2 real time clock update", NULL},
//       0x6c      BIOS    system resume vector
//       0x6d              reserved
//       0x6e              reserved
//       0x6f              reserved
       { 0x70, END, "IRQ8:real time clock", NULL},
       { 0x71, END, "IRQ9:software redirected to IRQ2", NULL},
       { 0x72, END, "IRQa:reserved", NULL},
       { 0x73, END, "IRQb:reserved", NULL},
       { 0x74, END, "IRQc:mouse interrupt", NULL},
       { 0x75, END, "IRQd:numeric coprocessor NMI error", NULL},
       { 0x76, END, "IRQe:fixed disk controller", NULL},
       { 0x77, END, "IRQf:reserved", NULL},
//       0x78              unused
//       0x79              unused
       { 0x7a, REG_BX, int7afns, "IPX"},     // Novell IPX
       { 0x7b, OFFSET+14, int7bfns, "Btrieve"},  // Novell Btrieve
  { -1, -1, NULL, NULL}
};

struct textID mainTable[]={
       { 0x00, INTERRUPT_NUMBER, interrupts, "interrupt"},
       {   -1,               -1, NULL,       NULL}
};

